OUTPUT_FORMAT("elf32-zpu", "elf32-zpu", "elf32-zpu")
OUTPUT_ARCH(zpu)
SEARCH_DIR(.);
ENTRY(_start)
SEARCH_DIR("/home/dbetz/zpugcc/toolchain/build/../install/zpu-elf/lib");

RAMSIZE = 64 * 1024;
ROMSIZE = 1 * 1024 * 1024;

MEMORY {
  ram : ORIGIN = 0x00000000, LENGTH = 64K
  rom : ORIGIN = 0x00100000, LENGTH = 1M
  hub : ORIGIN = 0x10000000, LENGTH = 64K
  cog : ORIGIN = 0x10008000, LENGTH = 2K
  io  : ORIGIN = 0x10008800, LENGTH = 1K
}
  
SECTIONS {
  .text : {
    LONG(_start)
    LONG(_data_image)
    LONG(_data_start)
    LONG(_data_end)
    LONG(_bss_start)
    LONG(_bss_end)
    KEEP(*(.fixed_vectors))
    KEEP(*(.init))
    *(.text)
    *(.text.*)
    KEEP(*(.fini))
    *(.rodata)
    *(.rodata.*)
    . = ALIGN(4);
    _data_image = .;
  } >rom
  .data : {
    _data_start = .;
    PROVIDE(_memreg = .);
    LONG(0)
    LONG(0)
    LONG(0)
    LONG(0)
    *(.data)
    *(.data.*)
    . = ALIGN(4);
  } >ram AT>rom
  .ctors : {
    ___ctors = .;
    KEEP (*crtbegin*.o(.ctors))
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
    ___ctors_end = .;
  } >ram AT>rom
  .dtors : {
    ___dtors = .;
    KEEP (*crtbegin*.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
    ___dtors_end = .;
    _data_end = .;
  } >ram AT>rom
  .bss : {
    _bss_start = .;
    *(.bss)
    *(.bss.*)
    . = ALIGN(4);
    _bss_end = .;
    _end = .;
  } >ram
  .stack RAMSIZE - 0x1000 : {
    _stack = .;
    *(.stack)
  } >ram
  .hub : {
    *(.hub)
  } >hub
  .cog : {
    *(.cog)
  } >cog
  .io : {
    *(.io)
  } >io
}
